package eu.eudat.dao.entities;

import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;

import javax.persistence.TypedQuery;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import org.hibernate.query.Query;

import eu.eudat.dao.JpaDao;
import eu.eudat.entities.DataRepository;
import eu.eudat.entities.responses.IDLabelPair;
import eu.eudat.models.criteria.Criteria;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

@Component("dataRepositoryDao")
public class DataRepositoryDaoImpl extends JpaDao<DataRepository, UUID> implements DataRepositoryDao {

	public DataRepository loadDetails(DataRepository t) {
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public List<UUID> listAllIDs() {
		String queryString = "SELECT dataRepository.id FROM DataRepository dataRepository";
		TypedQuery<UUID> typedQuery = entityManager.createQuery(queryString, UUID.class);
		return typedQuery.getResultList();
	}
	
	
	@Override
	public List<IDLabelPair> listAllIDsLabels() {
		String queryString = "SELECT dataRepository.id, dataRepository.label FROM DataRepository dataRepository";
		Query query = (Query) entityManager.createQuery(queryString);
		List<Object[]> rows = query.list();
		return rows.stream().map(row -> {
			return new IDLabelPair(row[0].toString(), row[1].toString());
		})
		.collect(Collectors.toList());
	}


	@Override
	public List<DataRepository> listBy(Criteria<DataRepository> criteria) {
		CriteriaBuilder criteriaBuilder = entityManager.getCriteriaBuilder();
		CriteriaQuery<DataRepository> criteriaQuery = criteriaBuilder .createQuery(DataRepository.class);	
		Root<DataRepository> root = criteriaQuery.from(DataRepository.class);
		criteriaQuery.where(criteriaBuilder.equal(root.get("reference"), criteria.getLike()));
		TypedQuery<DataRepository> typedQuery = entityManager.createQuery(criteriaQuery);
		return typedQuery.getResultList();
	}
	

}
