package eu.eudat.dao.entities;

import java.util.List;
import java.util.UUID;

import eu.eudat.dao.Dao;
import eu.eudat.entities.Project;
import eu.eudat.entities.responses.IDLabelPair;
import eu.eudat.models.project.ProjectTableRequest;
import org.springframework.stereotype.Service;

public interface ProjectDao extends Dao<Project, UUID> {

	public List<UUID> listAllIDs();

	public List<IDLabelPair> listAllIDsLabels();
	
	public List<Project> getProjectsOfUser(String userID);
	
	public List<Project> getWithCriteria(ProjectTableRequest projectTableRequest);
	
}