package eu.eudat.managers;

import java.util.List;
import java.util.UUID;

import eu.eudat.dao.entities.ProjectDao;
import eu.eudat.models.helpers.DataTableData;
import eu.eudat.models.project.Project;
import eu.eudat.models.project.ProjectTableRequest;
import eu.eudat.utilities.builders.DomainModelConverter;

public class ProjectManager {

	public DataTableData<eu.eudat.models.project.Project> getPaged(ProjectDao projectRepository, ProjectTableRequest projectTableRequest) throws IllegalAccessException, InstantiationException{
		List<eu.eudat.models.project.Project> projects = new DomainModelConverter<eu.eudat.entities.Project, Project>().fromDataModel( projectRepository.getWithCriteria(projectTableRequest), eu.eudat.models.project.Project.class);
		DataTableData<eu.eudat.models.project.Project> dataTable = new DataTableData<eu.eudat.models.project.Project>();
		dataTable.setData(projects);
		dataTable.setTotalCount(projectRepository.count());
		return dataTable;		
	}
	
	public eu.eudat.models.project.Project getSingle(ProjectDao projectRepository, String id) throws InstantiationException, IllegalAccessException{
		eu.eudat.models.project.Project project = new eu.eudat.models.project.Project();
		project.fromDataModel(projectRepository.read(UUID.fromString(id)));
		return project;
	}
}
