package eu.eudat.models.dmp;

import eu.eudat.entities.*;
import eu.eudat.models.DataModel;
import eu.eudat.utilities.builders.DomainModelConverter;

import java.util.*;
import java.util.stream.Collector;
import java.util.stream.Collectors;

public class DataManagementPlan implements DataModel<DMP>{
    private UUID id;
    private String label;
    private UUID previous;
    private int version;
    private int status;
    private eu.eudat.models.dmp.Project project;
    private List<Organisation> organizations;
    private List<Researcher> researchers;
    private UserInfo creator;
    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public UUID getPrevious() {
        return previous;
    }

    public void setPrevious(UUID previous) {
        this.previous = previous;
    }

    public int getVersion() {
        return version;
    }

    public void setVersion(int version) {
        this.version = version;
    }

    public List<Organisation> getOrganizations() {
        return organizations;
    }

    public void setOrganizations(List<Organisation> organizations) {
        this.organizations = organizations;
    }

    public List<Researcher> getResearchers() {
        return researchers;
    }

    public void setResearchers(List<Researcher> researchers) {
        this.researchers = researchers;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public eu.eudat.models.dmp.Project getProject() {
        return project;
    }

    public void setProject(eu.eudat.models.dmp.Project project) {
        this.project = project;
    }

    public UserInfo getCreator() {
		return creator;
	}

	public void setCreator(UserInfo creator) {
		this.creator = creator;
	}

	@Override
    public void fromDataModel(DMP entity) throws InstantiationException, IllegalAccessException {
        this.id = entity.getId();
        this.organizations =new DomainModelConverter<eu.eudat.entities.Organisation,Organisation>().fromDataModel(entity.getOrganisations().stream().collect(Collectors.toList()),Organisation.class);
        this.researchers =new DomainModelConverter<eu.eudat.entities.Researcher,Researcher>().fromDataModel(entity.getResearchers().stream().collect(Collectors.toList()),Researcher.class);
        this.version = entity.getVersion();
        this.previous = entity.getPrevious();
        this.label = entity.getLabel();
        this.project = new eu.eudat.models.dmp.Project();
        this.project.fromDataModel(entity.getProject());
        this.creator = new eu.eudat.models.dmp.UserInfo();
        if(entity.getCreator()!=null)this.creator.fromDataModel(entity.getCreator());
    }

    @Override
    public DMP toDataModel() {
        DMP dataManagementPlanEntity = new DMP();
        dataManagementPlanEntity.setId(this.id);
        dataManagementPlanEntity.setOrganisations(new HashSet<eu.eudat.entities.Organisation>(new DomainModelConverter<eu.eudat.entities.Organisation,Organisation>().toDataModel(this.organizations)));
        dataManagementPlanEntity.setResearchers(new HashSet<eu.eudat.entities.Researcher>(new DomainModelConverter<eu.eudat.entities.Researcher,Researcher>().toDataModel(this.researchers)));
        dataManagementPlanEntity.setVersion(this.version);
        dataManagementPlanEntity.setPrevious(this.previous);
        dataManagementPlanEntity.setLabel(this.label);
        dataManagementPlanEntity.setProject(this.project.toDataModel());
        return dataManagementPlanEntity;
    }
}
