import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';

import { TabComponent } from './tabs.component';
import { AuthGuard } from '../guards/auth.guard';
import { ProjectListingComponent } from '../projects/project-listing.component';
import { DataManagementPlanListingComponent } from '../dmps/dmp-listing.component';

const tabsRoutes: Routes = [
  {
    path: 'tabs', component: TabComponent, canActivate: [AuthGuard],
    children: [
      {
        path: 'projects',
        component: ProjectListingComponent
      },
      {
        path: 'dmps',
        component: DataManagementPlanListingComponent
      }
    ]
  },
  // { path: 'tabs/projects', component: ProjectListingComponent }, // canActivate: [AuthGuard]
  // { path: 'tabs/dmps', component: DataManagementPlanListingComponent }
];

@NgModule({
  imports: [
    RouterModule.forChild(tabsRoutes)
  ],
  exports: [
    RouterModule
  ]
})
export class TabRoutingModule { }